// 
// Class List
// Search             : Contains the Queries & Sub Queries
// SearchList         : Pointers to the Queries
// Condition          : holds the Condition Fields
// Filter             : holds the Combination of the Conditions
// QueryContainer     : contains the data elements of the combined query

// Gloabal Data Structures
var Data ;            // instance of Condition
var ObjectList ;      // instance of SearchList
var CombinedQuery ;   // instance of QueryContainer

var SelectedQuery ;   // integer number == Query Selected

// CLASS DEFINITIONS

// Search Class
function Search(Operand1,Operator,Operand2) {
         this.Operand1 = Operand1 ;
         this.Operand2 = Operand2 ;
         this.Operator = Operator ;
         // Methods:
         this.print_as_string = print_as_string ;
         this.print_as_query  = print_as_query ;
}
function print_as_string() {
         var Op1 = typeof(this.Operand1) ;
         var String = "( " ;
         if ( Op1 == "object" ) {
            String +=  this.Operand1.print_as_string()  ;
         } else {
            String += this.Operand1 ;
         }
         String += " " + this.Operator + " " ;
         var Op2 = typeof(this.Operand2) ;
         if ( Op2 == "object" ) {
            String +=  this.Operand2.print_as_string() ;
         } else {
            String += this.Operand2 ;
         }
         String +=  ")" ;
         return String ;
}
function print_as_query() {
         var Op1 = typeof(this.Operand1) ;
         var Op2 = typeof(this.Operand2) ;
         var String ;

         if ( isLogicOperator(this.Operator) ) {
            String = " ( " + this.Operator + this.Operand1.print_as_string() + this.Operand2.print_as_string() + " ) " ;
         } else {
            String = " ( " + this.Operand1 + " " + this.Operator + " " + this.Operand2 + " ) " ;
         }
         return String ;
}
function create_search() {
}
function SelectionList() {
}

// SearchList Class
function SearchList() {
         this.List = new Array();
         // Methods:
         this.addElement    = addElement ;
         this.getElement    = getElement ;
         this.refreshList   = refreshList ;
         this.deleteElement = deleteElement ;
}
function addElement(newElement) {
         var newElement = newElement ;
         this.List[this.List.length] = newElement ;
}
function getElement(Cntr) {
         var Cntr = Cntr ;
         return this.List[Cntr];
}
function deleteElement(Number) {
         var i ;
         Number = Number * 1 ;
         for ( i=Number ; i < this.List.length-1 ; i++ ) {
             this.List[i]=this.List[i+1];
         }
         this.List.length-- ;
         this.refreshList();
}
function refreshList() {
         var Cnt ;
         top.QueryList.document.open();
         top.QueryList.document.write("<H2>Query List</H2><P><HR>");
         top.QueryList.document.write("<FORM>");
         for ( Cnt = 0 ; Cnt < this.List.length ; Cnt++ ) {
             var Line  = 'Nr: '+ (Cnt+1) + ' <INPUT TYPE="radio" NAME="Queries" VALUE="' ;
                 Line += Cnt + '"' ;
                 Line += ' onclick=\'top.QueryBody.window.SelectQuery("' + Cnt + '");\' >' ;
                 Line += this.List[Cnt].print_as_string() + "<BR>";
             top.QueryList.document.write(Line);
         }
         top.QueryList.document.write("</FORM>");
         top.QueryList.document.close();
}


// Condition Class
function Condition(FieldList,OperatorList,Value) {
         this.FieldList      = FieldList;
         this.OperatorList   = OperatorList;
         this.Value          = Value;
         // Methods:
         this.getField       = getField ;
         this.getOperator1   = getOperator1 ;
         this.getValue       = getValue ;
}
function getField() {
         return this.FieldList[this.FieldList.selectedIndex].value ;
}
function getOperator1() {
         return this.OperatorList[this.OperatorList.selectedIndex].value ;
}
function getValue() {
         return this.Value.value ;
}


// Filter Class
function Filter(Condition1List,OperatorList,Condition2List) {
         this.Condition1List     = Condition1List;
         this.OperatorList       = OperatorList;
         this.Condition2List     = Condition2List;
         // Methods:
         this.getCondition1      = getCondition1 ;
         this.getCondition2      = getCondition2 ;
         this.getOperator2       = getOperator2 ;
}
function getCondition1() {
         return this.Condition1List[this.Condition1List.selectedIndex].value ;
}
function getCondition2() {
         return this.Condition2List[this.Condition2List.selectedIndex].value ;
}
function getOperator2() {
         return this.Condition2List[this.Condition2List.selectedIndex].value ;
}


// Data Container Class
function QueryContainer () {
         // both Operands are query objects
         // at the instantiation of the Container class all variables are null.
         this.FirstOperand;
         this.SecondOperand;
         this.Operator;
         this.FirstOpNr;
         this.SecondOpnr;
         // Methods
         this.setQC       = setQC;
         this.getQC       = getQC;
         this.displayData = displayData ;
         this.genQuery    = genQuery ;
}
function displayData() {
         top.Footer.document.open();
         top.Footer.document.write("<H2>Query List</H2><P><HR>");
         if ( this.FirstOperand != null ) {
            top.Footer.document.write(this.FirstOperand.print_as_string()) ;
         } 
         top.Footer.document.write("<BR>"); 
         if ( this.Operator != null ) {
            top.Footer.document.write(this.Operator) ;
         }
         top.Footer.document.write("<BR>"); 
         if ( this.SecondOperand != null ) {
            top.Footer.document.write(this.SecondOperand.print_as_string()) ;
         } 
         top.Footer.document.close();
}
function getQC() {
         return(this.FirstOperand,this.Operator,this.SecondOperator);
}
function setQC(Op1,Operator,Op2) {
         // Op1 & Op2 are both Integers !!!
         if ( Op1 != null ) {
              this.FirstOperand =  ObjectList.getElement(Op1) ;
              this.FirstOpNr = Op1 ;
         } 
         if ( Op2 != null ) {
              this.SecondOperand = ObjectList.getElement(Op2) ;
              this.SecondOpnr = Op2 ;
         } 
         if ( Operator != null ) {
              this.Operator = Operator ;
         }
}
function genQuery() {
         // Generates a complex query
         if ( this.FirstOperand != null && this.Operator != null && this.SecondOperand != null ) {
            var NewSearch = new Search(this.FirstOperand,this.Operator,this.SecondOperand);
            ObjectList.addElement(NewSearch);
            ObjectList.refreshList();
         } else {
            alert("Some operand is missing");
         }
}

// END CLASS DEFINITIONS



// To set up the whole thing.
function init() {
         CleanQueryList();
         var Form = window.document.Selection ;
         Data = new Condition(Form.S_FieldList,Form.S_OperatorList,Form.S_Value);
         ObjectList = new SearchList(); 
         CombinedQuery = new QueryContainer();
}
// Callbacks & other utilities
function SelectQuery(Number) {
         SelectedQuery = Number ;
}
function DeleteSelectedQuery(){
         if ( SelectedQuery == null) {
             alert("No Element Selected");
         } else {
             ObjectList.deleteElement(SelectedQuery);
         }
}
function NewQuery() {
         var Operator1 = Data.getField();
         var Operator2 = Data.getValue();
         var Operand   = Data.getOperator1();
         var NewSearch = new Search(Operator1,Operand,Operator2);
         ObjectList.addElement(NewSearch);
         ObjectList.refreshList();
}
function FirstOperator() {
         if ( SelectedQuery == null) {
             alert("No Element Selected");
         } else {
             //CombinedQuery.setQC( ObjectList.getElement(SelectedQuery),null,null);
             CombinedQuery.setQC(SelectedQuery,null,null);
             CombinedQuery.displayData();
         }
}
function SecondOperator() {
         if ( SelectedQuery == null) {
             alert("No Element Selected");
         } else {
             //CombinedQuery.setQC( null,null,ObjectList.getElement(SelectedQuery) );
             CombinedQuery.setQC(null,null,SelectedQuery);
             CombinedQuery.displayData();
         }
}
function AddOperator(List) {
         CombinedQuery.setQC( null,List[List.selectedIndex].value,null);
         CombinedQuery.displayData();
}
function AddCombinedQuery() {
         CombinedQuery.genQuery();
}
function CleanQueryList() {
         top.QueryList.document.open();
         top.QueryList.document.write("<H2>Query List Empty</H2><P><HR>");
         top.QueryList.document.close();
}
function PrintSelectedQuery() {
         if ( SelectedQuery == null) {
             alert("No Element Selected");
         } else {
             var Filter = ObjectList.getElement(SelectedQuery).print_as_query() ;
             alert(Filter);
         }
}

function isLogicOperator(Operator) {
         if ( Operator == "and" || Operator == "or" ) {
            return true ;
         } else {
            return false ;
         }
}
// For Debug Purpose Only:
// alert("JavaScript Loaded");

